/****************************/
/* new 演算子と代入・初期化 */
/*      coded by Y.Suganuma */
/****************************/
#include <stdio.h>

/*****************/
/* クラスComplex */
/*****************/
class Complex
{
	public:
		int x, y, a[2], *b;
		Complex ()
		{
			x    = 0;
			y    = 0;
			a[0] = 1;
			a[1] = 2;
			b    = new int[2];
			b[0] = 10;
			b[1] = 20;
		}
};

/********/
/* main */
/********/
int main()
{
			// 単純変数
	printf("*** 基本型 ***\n");
	int a1 = 0;
	int a2 = a1;
	printf("   変更前 a1 %d a2 %d\n", a1, a2);
	a2 = 100;
	printf("   変更後 a1 %d a2 %d\n", a1, a2);
	printf("*** 基本型（new） ***\n");
	int *b1 = new int (0);
	int *b2 = b1;
	printf("   変更前 *b1 %d *b2 %d\n", *b1, *b2);
	*b2 = 200;
	printf("   変更後 *b1 %d *b2 %d\n", *b1, *b2);
			// 配列
	printf("*** 配列 ***\n");
	int c1[2] = {0, 0}, c2[2];
	c2[0] = 1;
	c2[1] = 2;
	printf("   変更前 c1 %d %d c2 %d %d\n", c1[0], c1[1], c2[0], c2[1]);
	c2[1] = 10;
	printf("   変更後 c1 %d %d c2 %d %d\n", c1[0], c1[1], c2[0], c2[1]);
	printf("*** 配列（new） ***\n");
	int *d1 = new int[2], *d2;
	d1[0] = 1;
	d1[1] = 2;
	d2    = d1;
	printf("   変更前 d1 %d %d d2 %d %d\n", d1[0], d1[1], d2[0], d2[1]);
	d2[0] = 10;
	printf("   変更後 d1 %d %d d2 %d %d\n", d1[0], d1[1], d2[0], d2[1]);
			// クラスのオブジェクト
	printf("*** クラスのオブジェクト ***\n");
	Complex e1;
	Complex e2 = e1;
	printf("   変更前(e1) x %d y %d a %d %d b %d %d\n", e1.x, e1.y, e1.a[0], e1.a[1], e1.b[0], e1.b[1]);
	printf("   　　　(e2) x %d y %d a %d %d b %d %d\n", e2.x, e2.y, e2.a[0], e2.a[1], e2.b[0], e2.b[1]);
	e2.x    = 10;
	e2.a[0] = 20;
	e2.b[0] = 30;
	printf("   変更後(e1) x %d y %d a %d %d b %d %d\n", e1.x, e1.y, e1.a[0], e1.a[1], e1.b[0], e1.b[1]);
	printf("   　　　(e2) x %d y %d a %d %d b %d %d\n", e2.x, e2.y, e2.a[0], e2.a[1], e2.b[0], e2.b[1]);
			// クラスのオブジェクト（new）
	printf("*** クラスのオブジェクト（new） ***\n");
	Complex *f1 = new Complex();
	Complex *f2 = f1;
	printf("   変更前(f1) x %d y %d a %d %d b %d %d\n", f1->x, f1->y, f1->a[0], f1->a[1], f1->b[0], f1->b[1]);
	printf("   　　　(f2) x %d y %d a %d %d b %d %d\n", f2->x, f2->y, f2->a[0], f2->a[1], f2->b[0], f2->b[1]);
	f2->x    = 10;
	f2->a[0] = 20;
	f2->b[0] = 30;
	printf("   変更後(f1) x %d y %d a %d %d b %d %d\n", f1->x, f1->y, f1->a[0], f1->a[1], f1->b[0], f1->b[1]);
	printf("   　　　(f2) x %d y %d a %d %d b %d %d\n", f2->x, f2->y, f2->a[0], f2->a[1], f2->b[0], f2->b[1]);

	return 0;
}
