canvas  = null;
ctx     = null;
title   = null;   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
n_g     = 0;   // グラフの数
g_title = null;   // 各グラフのタイトル（凡例）
n_p     = 0;   // データの数
x_title = null;   // ｘ軸への表示内容
x_scale = null;   // ｘ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
xx_scale = null;   // x_scale の対数値
place_x = 0;   // ｘ軸の小数点以下桁数
y_scale = null;   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
place_y = 0;   // ｙ軸の小数点以下桁数
data_x  = null;   // データ（ｘ軸，n_g×n_p個）
data_y  = null;   // データ（ｙ軸，n_g×n_p個）
data_xx = null;   // data_x の対数値
d_t     = true;   // グラフタイトル表示の有無
d_g     = true;   // 凡例表示の有無
kind    = 0;   // グラフの種類
ver     = true;   // 縦か横か（ true が縦）
cx      = 0;   // 表示切り替えボタンのｘ座標
cy      = 0;   // 表示切り替えボタンのｙ座標
cw      = 0;   // 表示切り替えボタンの幅
ch      = 0;   // 表示切り替えボタンの高さ
x_base  = 0;   // キャンバスの左上のｘ座標
y_base  = 0;   // キャンバスの左上のｙ座標
cl      = new Array(10);   // グラフの色
cl[0]   = "rgb(0, 0, 0)";
cl[1]   = "rgb(255, 0, 255)";
cl[2]   = "rgb(0, 0, 255)";
cl[3]   = "rgb(128, 0, 128)";
cl[4]   = "rgb(0, 255, 255)";
cl[5]   = "rgb(0, 128, 128)";
cl[6]   = "rgb(0, 128, 0)";
cl[7]   = "rgb(192, 192, 192)";
cl[8]   = "rgb(255, 0, 0)";
cl[9]   = "rgb(128, 0, 0)";
clr = new Array (0, 255, 0, 128, 0, 0, 0, 192, 255, 128);
clg = new Array (0, 0, 0, 0, 255, 128, 128, 192, 0, 0);
clb = new Array (0, 255, 255, 128, 255, 128, 0, 192, 0, 0);
change = "";   // 表示切り替えボタン
line_w = 2;   // 折れ線グラフ等の線の太さ
line_m = true;   // 折れ線グラフ等にマークを付けるか否か
gpp = null;

/****************************/
/* グラフの描画             */
/*      coded by Y.Suganuma */
/****************************/
function graph(gp)
{
	canvas        = document.getElementById('canvas_e');
	canvas.width  = 900;   // キャンバス要素の幅
	canvas.height = 600;   // キャンバス要素の高さ
	ctx           = canvas.getContext('2d');   // キャンバスからコンテキストを取得
	x_base        = canvas.offsetLeft;   // キャンバスの左上のｘ座標
	y_base        = canvas.offsetTop;   // キャンバスの左上のｙ座標
	gpp           = gp;
					// データの分離とグラフの選択
	let a = gp.split(",");
	kind = parseInt(a[0]);   // グラフの種類
	let k = 1;
							//
							// 棒グラフ
							//
	if (kind == 0) {
		change = "縦　色";   // 表示切り替えボタン
		title = new Array(3);   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
		for (let i1 = 0; i1 < 3; i1++) {
			title[i1] = a[k];
			k++;
		}
		n_g = parseInt(a[k]);   // グラフの数
		g_title = new Array(n_g);   // 各グラフのタイトル（凡例）
		k++;
		for (let i1 = 0; i1 < n_g; i1++) {
			g_title[i1] = a[k];
			k++;
		}
		n_p = parseInt(a[k]);   // データの数
		x_title = new Array(n_p);   // ｘ軸への表示内容
		k++;
		for (let i1 = 0; i1 < n_p; i1++) {
			x_title[i1] = a[k];
			k++;
		}
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		data_y = new Array(n_g);   // データ（n_g×n_p個）
		for (let i1 = 0; i1 < n_g; i1++) {
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		if (parseInt(a[k+1]) == 0)   // 凡例の表示
			d_g = false;
		set();
		BarGraph();
	}
							//
							// 折れ線グラフ（１）
							//
	else if (kind == 1) {
		change = "縦　色";   // 表示切り替えボタン
		title = new Array(3);   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
		for (let i1 = 0; i1 < 3; i1++) {
			title[i1] = a[k];
			k++;
		}
		n_g = parseInt(a[k]);   // グラフの数
		g_title = new Array(n_g);   // 各グラフのタイトル（凡例）
		k++;
		for (let i1 = 0; i1 < n_g; i1++) {
			g_title[i1] = a[k];
			k++;
		}
		n_p = parseInt(a[k]);   // データの数
		x_title = new Array(n_p);   // ｘ軸への表示内容
		k++;
		for (let i1 = 0; i1 < n_p; i1++) {
			x_title[i1] = a[k];
			k++;
		}
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		data_y = new Array(n_g);   // データ（n_g×n_p個）
		for (let i1 = 0; i1 < n_g; i1++) {
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		if (parseInt(a[k+1]) == 0)   // 凡例の表示
			d_g = false;
		set();
		LineGraph1();
	}
							//
							// 折れ線グラフ（２）
							//
	else if (kind == 2) {
		change = "縦　色";   // 表示切り替えボタン
		title = new Array(3);   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
		for (let i1 = 0; i1 < 3; i1++) {
			title[i1] = a[k];
			k++;
		}
		n_g = parseInt(a[k]);   // グラフの数
		g_title = new Array(n_g);   // 各グラフのタイトル（凡例）
		k++;
		for (let i1 = 0; i1 < n_g; i1++) {
			g_title[i1] = a[k];
			k++;
		}
		x_scale = new Array(3);   // ｘ軸の最小値, ｘ軸の最大値, ｘ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			x_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_x = parseInt(a[k]);   // ｘ軸の小数点以下桁数
		k++;
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		n_p = parseInt(a[k]);   // データの数
		k++;
		data_x = new Array(n_g);   // ｘ軸のデータ（n_g×n_p個）
		data_y = new Array(n_g);   // ｙ軸のデータ（n_g×n_p個）
		for (let i1 = 0; i1 < n_g; i1++) {
			data_x[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_x[i1][i2] = parseFloat(a[k]);
				k++;
			}
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		if (parseInt(a[k+1]) == 0)   // 凡例の表示
			d_g = false;
		set();
		LineGraph2();
	}
							//
							// 積み上げ棒グラフ
							//
	else if (kind == 3) {
		change = "縦　色";   // 表示切り替えボタン
		title = new Array(3);   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
		for (let i1 = 0; i1 < 3; i1++) {
			title[i1] = a[k];
			k++;
		}
		n_g = parseInt(a[k]);   // グラフの数
		g_title = new Array(n_g);   // 各グラフのタイトル（凡例）
		k++;
		for (let i1 = 0; i1 < n_g; i1++) {
			g_title[i1] = a[k];
			k++;
		}
		n_p = parseInt(a[k]);   // データの数
		x_title = new Array(n_p);   // ｘ軸への表示内容（凡例）
		k++;
		for (let i1 = 0; i1 < n_p; i1++) {
			x_title[i1] = a[k];
			k++;
		}
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		data_y = new Array(n_g);   // データ（n_g×n_p個）
		for (let i1 = 0; i1 < n_g; i1++) {
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		if (parseInt(a[k+1]) == 0)   // 凡例の表示
			d_g = false;
		set();
		StackGraph();
	}
							//
							// 円グラフ
							//
	else if (kind == 4) {
		change = "　色　";   // 表示切り替えボタン
		title = new Array();   // グラフタイトル
		title[0] = a[k];
		k++;
		n_p = parseInt(a[k]);   // データの数
		x_title = new Array(n_p);   // 凡例
		k++;
		for (let i1 = 0; i1 < n_p; i1++) {
			x_title[i1] = a[k];
			k++;
		}
		data_y = new Array();   // データ（n_p個）
		for (let i1 = 0; i1 < n_p; i1++) {
			data_y[i1] = parseFloat(a[k]);
			k++;
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		set();
		PieGraph();
	}
							//
							// 散布図
							//
	else if (kind == 5) {
		title = new Array(3);   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
		for (let i1 = 0; i1 < 3; i1++) {
			title[i1] = a[k];
			k++;
		}
		x_scale = new Array(3);   // ｘ軸の最小値, ｘ軸の最大値, ｘ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			x_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_x = parseInt(a[k]);   // ｘ軸の小数点以下桁数
		k++;
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		n_p = parseInt(a[k]);   // データの数
		k++;
		data_y = new Array(2);   // データ（2×n_p個）
		for (let i1 = 0; i1 < 2; i1++) {
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		ScatterDiagram();
	}
							//
							// レーダーチャート
							//
	else if (kind == 6) {
		change = "　色　";   // 表示切り替えボタン
		title    = new Array(1);   // グラフタイトル
		title[0] = a[k];
		k++;
		n_g = parseInt(a[k]);   // グラフの数
		g_title = new Array(n_g);   // 各グラフのタイトル（凡例）
		k++;
		for (let i1 = 0; i1 < n_g; i1++) {
			g_title[i1] = a[k];
			k++;
		}
		n_p = parseInt(a[k]);   // データの数
		x_title = new Array(n_p);   // ｘ軸への表示内容
		k++;
		for (let i1 = 0; i1 < n_p; i1++) {
			x_title[i1] = a[k];
			k++;
		}
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		data_y = new Array(n_g);   // データ（n_g×n_p個）
		for (let i1 = 0; i1 < n_g; i1++) {
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		if (parseInt(a[k+1]) == 0)   // 凡例の表示
			d_g = false;
		set();
		RadarChart();
	}
							//
							// ボード線図（片対数グラフ）
							//
	else {
		change = "　色　";   // 表示切り替えボタン
		title = new Array(3);   // グラフタイトル, ｘ軸タイトル, ｙ軸タイトル
		for (let i1 = 0; i1 < 3; i1++) {
			title[i1] = a[k];
			k++;
		}
		n_g = parseInt(a[k]);   // グラフの数
		g_title = new Array(n_g);   // 各グラフのタイトル（凡例）
		k++;
		for (let i1 = 0; i1 < n_g; i1++) {
			g_title[i1] = a[k];
			k++;
		}
		x_scale = new Array(3);   // ｘ軸の最小値, ｘ軸の最大値, ｘ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			x_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_x = parseInt(a[k]);   // ｘ軸の小数点以下桁数
		k++;
		y_scale = new Array(3);   // ｙ軸の最小値, ｙ軸の最大値, ｙ軸の刻み幅
		for (let i1 = 0; i1 < 3; i1++) {
			y_scale[i1] = parseFloat(a[k]);
			k++;
		}
		place_y = parseInt(a[k]);   // ｙ軸の小数点以下桁数
		k++;
		n_p = parseInt(a[k]);   // データの数
		k++;
		data_x = new Array(n_g);   // ｘ軸のデータ（n_g×n_p個）
		data_y = new Array(n_g);   // ｙ軸のデータ（n_g×n_p個）
		for (let i1 = 0; i1 < n_g; i1++) {
			data_x[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_x[i1][i2] = parseFloat(a[k]);
				k++;
			}
			data_y[i1] = new Array(n_p);
			for (let i2 = 0; i2 < n_p; i2++) {
				data_y[i1][i2] = parseFloat(a[k]);
				k++;
			}
		}
		if (parseInt(a[k]) == 0)   // グラフタイトルの表示
			d_t = false;
		if (parseInt(a[k+1]) == 0)   // 凡例の表示
			d_g = false;
		set();
		Bode();
	}
}

/****************************/
/* 表示変更エリアの設定     */
/*      coded by Y.Suganuma */
/****************************/
function set()
{
	let rgb ="rgb";
	let r ="r";
	let g ="g";
	let b ="b";
	for (let i1 = 0; i1 < 10; i1++) {
		let rgb1 = rgb + i1;
		document.getElementById(rgb1).style.backgroundColor = cl[i1];
		let r1 = r + i1;
		document.getElementById(r1).value = clr[i1];
		let g1 = g + i1;
		document.getElementById(g1).value = clg[i1];
		let b1 = b + i1;
		document.getElementById(b1).value = clb[i1];
	}
}

/****************************/
/* 棒グラフの描画           */
/*      coded by Y.Suganuma */
/****************************/
function BarGraph()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx = x_r - met.width - 5;
	cy = y_u;
	cw = met.width + 5;
	ch = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let met = ctx.measureText(g_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		let k  = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(g_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// ｘ軸及びｙ軸のタイトルの表示
					//
							// 縦表示
	ctx.fillStyle = 'rgb(0, 0, 0)';
	if (ver) {
		if (title[1].length > 0 && title[1] != "-") {
			let met = ctx.measureText(title[1]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[1], px, py);
			y_d -= (f_size + 5);
		}
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[2], px, py);
			y_u += 4 * f_size / 5;
		}
	}
							// 横表示
	else {
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[2], px, py);
			y_d -= (f_size + 5);
		}
		if (title[1].length > 0 && title[1].localeCompare("-") != 0) {
			let met = ctx.measureText(title[1]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[1], px, py);
			y_u += 4 * f_size / 5;
		}
	}
	y_u += 10;
					//
					// ｘ軸，ｙ軸，及び，各軸の目盛り
					//
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font  = f_size + "px 'ＭＳ 明朝'";
	y_d      -= (f_size + 5);
							// 縦表示
	if (ver) {
									// ｙ軸
		let y1  = y_scale[0];
		let k   = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let len = 0;
		let b   = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let yy = Math.round(y1 * b).toString();
			if (place_y == 0)
				tx[i1] = yy;
			else {
				if (yy.length < place_y+1) {
					let n = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				tx[i1] = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(tx[i1]);
			if (met.width > len)
				len = met.width;
			y1 += y_scale[2];
		}
		ctx.moveTo(x_l+len+10, y_u);
		ctx.lineTo(x_l+len+10, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		y1 = y_scale[0];
		let x1 = y_d;
		let sp = (y_d - y_u) / k;
		for (let i1 = 0; i1 < k+1; i1++) {
			let ky  = Math.floor(Math.round(x1));
			let met = ctx.measureText(tx[i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(tx[i1], px, py);
			ctx.moveTo(x_l+len+10, ky);
			ctx.lineTo(x_r, ky);
			y1 += y_scale[2];
			x1 -= sp;
		}
		x_l += (len + 10);
									// ｘ軸
		sp  = (x_r - x_l) / n_p;
		x1  = x_l + sp / 2.0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let kx  = Math.floor(Math.round(x1));
			let met = ctx.measureText(x_title[i1]);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + 11 * f_size / 10;
			ctx.fillText(x_title[i1], px, py);
			ctx.moveTo(kx, y_d);
			ctx.lineTo(kx, y_d-5);
			x1 += sp;
		}
	}
							// 横表示
	else {
									// ｙ軸
		let len = 0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let met = ctx.measureText(x_title[i1]);
			if (met.width > len)
				len = met.width;
		}
		ctx.moveTo(x_l+len+5, y_u);
		ctx.lineTo(x_l+len+5, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		let sp = (y_d - y_u) / n_p;
		let y1 = y_d - sp / 2.0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let ky  = Math.floor(Math.round(y1));
			let met = ctx.measureText(x_title[n_p-1-i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(x_title[n_p-1-i1], px, py);
			ctx.moveTo(x_l+len+5, ky);
			ctx.lineTo(x_l+len+10, ky);
			y1 -= sp;
		}
		ctx.moveTo(x_l+len+5, y_u);
		ctx.lineTo(x_r, y_u);
		ctx.moveTo(x_l+len+5, y_d);
		ctx.lineTo(x_r, y_d);
		x_l += (len + 5);
									// ｘ軸
		let k  = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let x1 = y_scale[0];
		y1 = x_l;
		sp = (x_r - x_l) / k;
		let b = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let kx = Math.floor(Math.round(y1));
			let yy = Math.round(x1 * b).toString();
			let st;
			if (place_y == 0)
				st = yy;
			else {
				if (yy.length < place_y+1) {
					n = place_y + 1 - yy.length;
					for (i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				st = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(st);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + f_size;
			ctx.fillText(st, px, py);
			if (i1 < k) {
				ctx.moveTo(kx, y_d);
				ctx.lineTo(kx, y_u);
			}
			x1 += y_scale[2];
			y1 += sp;
		}
	}
	ctx.stroke();
					//
					// グラフの表示
					//
							// 縦表示
	if (ver) {
		let g_w = Math.floor(0.8 * (x_r - x_l) / (n_g * n_p));
		let sp  = (x_r - x_l) / n_p;
		let x1  = x_l + sp / 2.0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let kx = Math.floor(Math.round(x1));
			let k1 = 0;
			let k2 = kx - n_g * g_w / 2;
			for (let i2 = 0; i2 < n_g; i2++) {
				let ky = y_d - Math.floor((y_d - y_u) * (data_y[i2][i1] - y_scale[0]) / (y_scale[1] - y_scale[0]));
				ctx.fillStyle = cl[k1];
				ctx.fillRect(k2, ky, g_w, y_d-ky);
				k2 += g_w;
				k1++;
				if (k1 > 9)
					k1 = 0;
			}
			x1 += sp;
		}
	}
							// 横表示
	else {
		let g_w = Math.floor(0.8 * (y_d - y_u) / (n_g * n_p));
		let sp  = (y_d - y_u) / n_p;
		let y1  = y_d - sp / 2.0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let ky = Math.floor(Math.round(y1));
			let k1 = 0;
			let k2 = ky - n_g * g_w / 2;
			for (let i2 = 0; i2 < n_g; i2++) {
				let kx = Math.floor((x_r - x_l) * (data_y[i2][n_p-1-i1] - y_scale[0]) / (y_scale[1] - y_scale[0]));
				ctx.fillStyle = cl[k1];
				ctx.fillRect(x_l, k2, kx, g_w);
				k2 += g_w;
				k1++;
				if (k1 > 9)
					k1 = 0;
			}
			y1 -= sp;
		}
	}
}

/****************************/
/* 折れ線グラフ（１）の描画 */
/*      coded by Y.Suganuma */
/****************************/
function LineGraph1()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx  = x_r - met.width - 5;
	cy  = y_u;
	cw  = met.width + 5;
	ch  = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let met = ctx.measureText(g_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		let k  = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(g_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// ｘ軸及びｙ軸のタイトルの表示
					//
							// 縦表示
	ctx.fillStyle = 'rgb(0, 0, 0)';
	if (ver) {
		if (title[1].length > 0 && title[1] != "-") {
			let met = ctx.measureText(title[1]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[1], px, py);
			y_d -= (f_size + 5);
		}
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[2], px, py);
			y_u += 4 * f_size / 5;
		}
	}
							// 横表示
	else {
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[2], px, py);
			y_d -= (f_size + 5);
		}
		if (title[1].length > 0 && title[1].localeCompare("-") != 0) {
			let met = ctx.measureText(title[1]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[1], px, py);
			y_u += 4 * f_size / 5;
		}
	}
	y_u += 10;
					//
					// ｘ軸，ｙ軸，及び，各軸の目盛り
					//
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font  = f_size + "px 'ＭＳ 明朝'";
	y_d      -= (f_size + 5);
							// 縦表示
	if (ver) {
									// ｙ軸
		let y1  = y_scale[0];
		let k   = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let len = 0;
		let b   = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let yy = Math.round(y1 * b).toString();
			if (place_y == 0)
				tx[i1] = yy;
			else {
				if (yy.length < place_y+1) {
					let n = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				tx[i1] = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(tx[i1]);
			if (met.width > len)
				len = met.width;
			y1 += y_scale[2];
		}
		ctx.moveTo(x_l+len+10, y_u);
		ctx.lineTo(x_l+len+10, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		y1 = y_scale[0];
		let x1 = y_d;
		let sp = (y_d - y_u) / k;
		for (let i1 = 0; i1 < k+1; i1++) {
			let ky  = Math.floor(Math.round(x1));
			let met = ctx.measureText(tx[i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(tx[i1], px, py);
			ctx.moveTo(x_l+len+10, ky);
			ctx.lineTo(x_r, ky);
			y1 += y_scale[2];
			x1 -= sp;
		}
		x_l += (len + 10);
									// ｘ軸
		sp  = (x_r - x_l) / n_p;
		x1  = x_l + sp / 2.0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let kx  = Math.floor(Math.round(x1));
			let met = ctx.measureText(x_title[i1]);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + 11 * f_size / 10;
			ctx.fillText(x_title[i1], px, py);
			ctx.moveTo(kx, y_d);
			ctx.lineTo(kx, y_d-5);
			x1 += sp;
		}
	}
							// 横表示
	else {
									// ｙ軸
		let len = 0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let met = ctx.measureText(x_title[i1]);
			if (met.width > len)
				len = met.width;
		}
		ctx.moveTo(x_l+len+5, y_u);
		ctx.lineTo(x_l+len+5, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		let sp = (y_d - y_u) / n_p;
		let y1 = y_d - sp / 2.0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let ky  = Math.floor(Math.round(y1));
			let met = ctx.measureText(x_title[n_p-1-i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(x_title[n_p-1-i1], px, py);
			ctx.moveTo(x_l+len+5, ky);
			ctx.lineTo(x_l+len+10, ky);
			y1 -= sp;
		}
		ctx.moveTo(x_l+len+5, y_u);
		ctx.lineTo(x_r, y_u);
		ctx.moveTo(x_l+len+5, y_d);
		ctx.lineTo(x_r, y_d);
		x_l += (len + 5);
									// ｘ軸
		let k  = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let x1 = y_scale[0];
		y1 = x_l;
		sp = (x_r - x_l) / k;
		let b = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let kx = Math.floor(Math.round(y1));
			let yy = Math.round(x1 * b).toString();
			let st;
			if (place_y == 0)
				st = yy;
			else {
				if (yy.length < place_y+1) {
					nlet  = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				st = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(st);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + f_size;
			ctx.fillText(st, px, py);
			if (i1 < k) {
				ctx.moveTo(kx, y_d);
				ctx.lineTo(kx, y_u);
			}
			x1 += y_scale[2];
			y1 += sp;
		}
	}
	ctx.stroke();
					//
					// グラフの表示
					//
	ctx.lineWidth = line_w;
	let cr = line_w / 2 + 3;
									// 縦表示
	if (ver) {
		let sp = (x_r - x_l) / n_p;
		let k1 = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let x1  = x_l + sp / 2.0;
			let kx1 = 0;
			let ky1 = 0;
			ctx.strokeStyle = cl[k1];  
			ctx.fillStyle   = cl[k1];
			for (let i2 = 0; i2 < n_p; i2++) {
				let kx = Math.floor(Math.round(x1));
				let ky = y_d - Math.floor((y_d - y_u) * (data_y[i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]));
				if (line_m) {
					ctx.beginPath();
					ctx.arc(kx, ky, cr, 0, 2*Math.PI, false);
					ctx.fill();
				}
				if (i2 > 0) {
					ctx.beginPath();
					ctx.moveTo(kx1, ky1);
					ctx.lineTo(kx, ky);
					ctx.stroke();
				}
				kx1  = kx;
				ky1  = ky;
				x1  += sp;
			}
			k1++;
			if (k1 > 9)
				k1 = 0;
		}
	}
									// 横表示
	else {
		let sp = (y_d - y_u) / n_p;
		let k1 = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let y1  = y_d - sp / 2.0;
			let kx1 = 0;
			let ky1 = 0;
			ctx.strokeStyle = cl[k1];  
			ctx.fillStyle   = cl[k1];
			for (let i2 = 0; i2 < n_p; i2++) {
				let ky = Math.floor(Math.round(y1));
				let kx = x_l + Math.floor((x_r - x_l) * (data_y[i1][n_p-1-i2] - y_scale[0]) / (y_scale[1] - y_scale[0]));
				if (line_m) {
					ctx.beginPath();
					ctx.arc(kx, ky, cr, 0, 2*Math.PI, false);
					ctx.fill();
				}
				if (i2 > 0) {
					ctx.beginPath();
					ctx.moveTo(kx1, ky1);
					ctx.lineTo(kx, ky);
					ctx.stroke();
				}
				kx1  = kx;
				ky1  = ky;
				y1  -= sp;
			}
			k1++;
			if (k1 > 9)
				k1 = 0;
		}
	}
	ctx.lineWidth = 1;
}

/****************************/
/* 折れ線グラフ（２）の描画 */
/*      coded by Y.Suganuma */
/****************************/
function LineGraph2()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx  = x_r - met.width - 5;
	cy  = y_u;
	cw  = met.width + 5;
	ch  = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let met = ctx.measureText(g_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		let k  = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(g_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// ｘ軸及びｙ軸のタイトルの表示
					//
							// 縦表示
	ctx.fillStyle = 'rgb(0, 0, 0)';
	if (ver) {
		if (title[1].length > 0 && title[1] != "-") {
			let met = ctx.measureText(title[1]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[1], px, py);
			y_d -= (f_size + 5);
		}
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[2], px, py);
			y_u += 4 * f_size / 5;
		}
	}
							// 横表示
	else {
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[2], px, py);
			y_d -= (f_size + 5);
		}
		if (title[1].length > 0 && title[1].localeCompare("-") != 0) {
			let met = ctx.measureText(title[1]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[1], px, py);
			y_u += 4 * f_size / 5;
		}
	}
	y_u += 10;
					//
					// ｘ軸，ｙ軸，及び，各軸の目盛り
					//
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font  = f_size + "px 'ＭＳ 明朝'";
	y_d      -= (f_size + 5);
							// 縦表示
	if (ver) {
									// ｙ軸
		let y1  = y_scale[0];
		let k   = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let len = 0;
		let b   = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let yy = Math.round(y1 * b).toString();
			if (place_y == 0)
				tx[i1] = yy;
			else {
				if (yy.length < place_y+1) {
					let n = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				tx[i1] = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(tx[i1]);
			if (met.width > len)
				len = met.width;
			y1 += y_scale[2];
		}
		ctx.moveTo(x_l+len+10, y_u);
		ctx.lineTo(x_l+len+10, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		y1 = y_scale[0];
		let x1 = y_d;
		let sp = (y_d - y_u) / k;
		for (let i1 = 0; i1 < k+1; i1++) {
			let ky  = Math.floor(Math.round(x1));
			let met = ctx.measureText(tx[i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(tx[i1], px, py);
			ctx.moveTo(x_l+len+10, ky);
			ctx.lineTo(x_r, ky);
			y1 += y_scale[2];
			x1 -= sp;
		}
		x_l += (len + 10);
									// ｘ軸
		k  = Math.floor((x_scale[1] - x_scale[0]) / (0.99 * x_scale[2]));
		x1 = x_scale[0];
		y1 = x_l;
		sp = (x_r - x_l) / k;
		b  = Math.pow(10, place_x);
		for (let i1 = 0; i1 < k+1; i1++) {
			let kx = Math.floor(Math.round(y1));
			let yy = Math.round(x1 * b).toString();
			let st;
			if (place_x == 0)
				st = yy;
			else {
				if (yy.length < place_x+1) {
					let n = place_x + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				st = yy.substr(0,yy.length-place_x) + "." + yy.substr(yy.length-place_x,place_x);
			}
			met = ctx.measureText(st);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + f_size;
			ctx.fillText(st, px, py);
			if (i1 < k) {
				ctx.moveTo(kx, y_d);
				ctx.lineTo(kx, y_u);
			}
			x1 += x_scale[2];
			y1 += sp;
		}
	}
							// 横表示
	else {
									// ｙ軸
		let y1  = x_scale[0];
		let k   = Math.floor((x_scale[1] - x_scale[0]) / (0.99 * x_scale[2]));
		let len = 0;
		let b   = Math.pow(10, place_x);
		for (let i1 = 0; i1 < k+1; i1++) {
			let yy = Math.round(y1 * b).toString();
			if (place_x == 0)
				tx[i1] = yy;
			else {
				if (yy.length < place_x+1) {
					let n = place_x + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				tx[i1] = yy.substr(0,yy.length-place_x) + "." + yy.substr(yy.length-place_x,place_x);
			}
			let met = ctx.measureText(tx[i1]);
			if (met.width > len)
				len = met.width;
			y1 += x_scale[2];
		}
		ctx.moveTo(x_l+len+10, y_u);
		ctx.lineTo(x_l+len+10, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		y1 = x_scale[0];
		let x1 = y_d;
		let sp = (y_d - y_u) / k;
		for (let i1 = 0; i1 < k+1; i1++) {
			let ky  = Math.floor(Math.round(x1));
			let met = ctx.measureText(tx[i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(tx[i1], px, py);
			ctx.moveTo(x_l+len+10, ky);
			ctx.lineTo(x_r, ky);
			y1 += x_scale[2];
			x1 -= sp;
		}
		x_l += (len + 10);
									// ｘ軸
		k  = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		x1 = y_scale[0];
		y1 = x_l;
		sp = (x_r - x_l) / k;
		b  = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let kx = Math.floor(Math.round(y1));
			let yy = Math.round(x1 * b).toString();
			let st;
			if (place_y == 0)
				st = yy;
			else {
				if (yy.length < place_y+1) {
					let n = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				st = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(st);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + f_size;
			ctx.fillText(st, px, py);
			if (i1 < k) {
				ctx.moveTo(kx, y_d);
				ctx.lineTo(kx, y_u);
			}
			x1 += y_scale[2];
			y1 += sp;
		}
	}
	ctx.stroke();
					//
					// グラフの表示
					//
	ctx.lineWidth = line_w;
	let cr = line_w / 2 + 3;
							// 縦表示
	if (ver) {
		let k1 = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let kx1 = 0;
			let ky1 = 0;
			ctx.strokeStyle = cl[k1];  
			ctx.fillStyle   = cl[k1];
			for (let i2 = 0; i2 < n_p; i2++) {
				let kx = x_l + Math.floor((x_r - x_l) * (data_x[i1][i2] - x_scale[0]) / (x_scale[1] - x_scale[0]));
				let ky = y_d - Math.floor((y_d - y_u) * (data_y[i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]));
				if (line_m) {
					ctx.beginPath();
					ctx.arc(kx, ky, cr, 0, 2*Math.PI, false);
					ctx.fill();
				}
				if (i2 > 0) {
					ctx.beginPath();
					ctx.moveTo(kx1, ky1);
					ctx.lineTo(kx, ky);
					ctx.stroke();
				}
				kx1 = kx;
				ky1 = ky;
			}
			k1++;
			if (k1 > 9)
				k1 = 0;
		}
	}
							// 横表示
	else {
		let k1  = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let kx1 = 0;
			let ky1 = 0;
			ctx.strokeStyle = cl[k1];  
			ctx.fillStyle   = cl[k1];
			for (let i2 = 0; i2 < n_p; i2++) {
				let kx = x_l + Math.floor((x_r - x_l) * (data_y[i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]));
				let ky = y_d - Math.floor((y_d - y_u) * (data_x[i1][i2] - x_scale[0]) / (x_scale[1] - x_scale[0]));
				if (line_m) {
					ctx.beginPath();
					ctx.arc(kx, ky, cr, 0, 2*Math.PI, false);
					ctx.fill();
				}
				if (i2 > 0) {
					ctx.beginPath();
					ctx.moveTo(kx1, ky1);
					ctx.lineTo(kx, ky);
					ctx.stroke();
				}
				kx1 = kx;
				ky1 = ky;
			}
			k1++;
			if (k1 > 9)
				k1 = 0;
		}
	}
	ctx.lineWidth = 1;
}

/****************************/
/* 積み上げ棒グラフの描画   */
/*      coded by Y.Suganuma */
/****************************/
function StackGraph()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx  = x_r - met.width - 5;
	cy  = y_u;
	cw  = met.width + 5;
	ch  = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let met = ctx.measureText(x_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		let k  = 0;
		for (let i1 = 0; i1 < n_p; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(x_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// ｘ軸及びｙ軸のタイトルの表示
					//
							// 縦表示
	ctx.fillStyle = 'rgb(0, 0, 0)';
	if (ver) {
		if (title[1].length > 0 && title[1] != "-") {
			let met = ctx.measureText(title[1]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[1], px, py);
			y_d -= (f_size + 5);
		}
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[2], px, py);
			y_u += 4 * f_size / 5;
		}
	}
							// 横表示
	else {
		if (title[2].length > 0 && title[2] != "-") {
			let met = ctx.measureText(title[2]);
			let px  = (x_l + x_r) / 2 - met.width / 2;
			let py  = y_d - 5;
			ctx.fillText(title[2], px, py);
			y_d -= (f_size + 5);
		}
		if (title[1].length > 0 && title[1].localeCompare("-") != 0) {
			let met = ctx.measureText(title[1]);
			let px  = x_l;
			let py  = y_u + 4 * f_size / 5;
			ctx.fillText(title[1], px, py);
			y_u += 4 * f_size / 5;
		}
	}
	y_u += 10;
					//
					// ｘ軸，ｙ軸，及び，各軸の目盛り
					//
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font  = f_size + "px 'ＭＳ 明朝'";
	y_d      -= (f_size + 5);
							// 縦表示
	if (ver) {
									// ｙ軸
		let y1  = y_scale[0];
		let k   = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let len = 0;
		let b   = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let yy = Math.round(y1 * b).toString();
			if (place_y == 0)
				tx[i1] = yy;
			else {
				if (yy.length < place_y+1) {
					let n = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				tx[i1] = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(tx[i1]);
			if (met.width > len)
				len = met.width;
			y1 += y_scale[2];
		}
		ctx.moveTo(x_l+len+10, y_u);
		ctx.lineTo(x_l+len+10, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		y1 = y_scale[0];
		let x1 = y_d;
		let sp = (y_d - y_u) / k;
		for (let i1 = 0; i1 < k+1; i1++) {
			let ky  = Math.floor(Math.round(x1));
			let met = ctx.measureText(tx[i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(tx[i1], px, py);
			ctx.moveTo(x_l+len+10, ky);
			ctx.lineTo(x_r, ky);
			y1 += y_scale[2];
			x1 -= sp;
		}
		x_l += (len + 10);
									// ｘ軸
		sp  = (x_r - x_l) / n_g;
		x1  = x_l + sp / 2.0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let kx  = Math.floor(Math.round(x1));
			let met = ctx.measureText(g_title[i1]);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + 11 * f_size / 10;
			ctx.fillText(g_title[i1], px, py);
			ctx.moveTo(kx, y_d);
			ctx.lineTo(kx, y_d-5);
			x1 += sp;
		}
	}
							// 横表示
	else {
									// ｙ軸
		let len = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let met = ctx.measureText(g_title[i1]);
			if (met.width > len)
				len = met.width;
		}
		ctx.moveTo(x_l+len+5, y_u);
		ctx.lineTo(x_l+len+5, y_d);
		ctx.moveTo(x_r, y_u);
		ctx.lineTo(x_r, y_d);
		let sp = (y_d - y_u) / n_g;
		let y1 = y_d - sp / 2.0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let ky  = Math.floor(Math.round(y1));
			let met = ctx.measureText(g_title[n_g-1-i1]);
			let k1  = met.width;
			let px  = x_l + len - k1;
			let py  = ky + 2 * f_size / 5;
			ctx.fillText(g_title[n_g-1-i1], px, py);
			ctx.moveTo(x_l+len+5, ky);
			ctx.lineTo(x_l+len+10, ky);
			y1 -= sp;
		}
		ctx.moveTo(x_l+len+5, y_u);
		ctx.lineTo(x_r, y_u);
		ctx.moveTo(x_l+len+5, y_d);
		ctx.lineTo(x_r, y_d);
		x_l += (len + 5);
									// ｘ軸
		let k  = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
		let x1 = y_scale[0];
		y1 = x_l;
		sp = (x_r - x_l) / k;
		let b = Math.pow(10, place_y);
		for (let i1 = 0; i1 < k+1; i1++) {
			let kx = Math.floor(Math.round(y1));
			let yy = Math.round(x1 * b).toString();
			let st;
			if (place_y == 0)
				st = yy;
			else {
				if (yy.length < place_y+1) {
					let n = place_y + 1 - yy.length;
					for (let i2 = 0; i2 < n; i2++)
						yy = "0" + yy;
				}
				st = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
			}
			let met = ctx.measureText(st);
			let k1  = met.width;
			let px  = kx - k1 / 2;
			let py  = y_d + f_size;
			ctx.fillText(st, px, py);
			if (i1 < k) {
				ctx.moveTo(kx, y_d);
				ctx.lineTo(kx, y_u);
			}
			x1 += y_scale[2];
			y1 += sp;
		}
	}
	ctx.stroke();
					//
					// グラフの表示
					//
							// 縦表示
	if (ver) {
		let g_w = Math.floor(0.8 * (x_r - x_l) / n_g);
		let sp  = (x_r - x_l) / n_g;
		let x1  = x_l + sp / 2.0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let kx = Math.round(x1);
			let k1 = 0;
			let y1 = y_d;
			for (let i2 = 0; i2 < n_p; i2++) {
				let ky = Math.round(y1);
				let y2 = (y_d - y_u) * (data_y[i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]);
				let k2 = Math.round(y2);
				ctx.fillStyle = cl[k1];
				ctx.fillRect(kx-g_w/2, ky-k2, g_w, k2);
				y1 -= y2;
				k1++;
				if (k1 > 9)
					k1 = 0;
			}
			x1 += sp;
		}
	}
							// 横表示
	else {
		let g_w = Math.floor(0.8 * (y_d - y_u) / n_g);
		let sp  = (y_d - y_u) / n_g;
		let y1  = y_d - sp / 2.0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let ky = Math.round(y1);
			let k1 = 0;
			let x1 = x_l;
			for (let i2 = 0; i2 < n_p; i2++) {
				let kx = Math.round(x1);
				let y2 = (x_r - x_l) * (data_y[n_g-1-i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]);
				let k2 = Math.round(y2);
				ctx.fillStyle = cl[k1];
				ctx.fillRect(kx, ky-g_w/2, k2, g_w);
				x1 += y2;
				k1++;
				if (k1 > 9)
					k1 = 0;
			}
			y1 -= sp;
		}
	}
}

/****************************/
/* 円グラフの描画           */
/*      coded by Y.Suganuma */
/****************************/
function PieGraph()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx  = x_r - met.width - 5;
	cy  = y_u;
	cw  = met.width + 5;
	ch  = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	let k = 0;
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_p; i1++) {
			let met = ctx.measureText(x_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		for (let i1 = 0; i1 < n_p; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(x_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// グラフの表示
					//
	let k1;
	if (x_r-x_l < y_d-y_u)
		k1 = x_r - x_l;
	else
		k1 = y_d - y_u;
	let len = 9 * k1 / 20;
	let kx  = (x_r + x_l) / 2;
	let ky  = (y_d + y_u) / 2;
	let a1  = 90;
	let a2  = a1 + Math.round(3.60 * data_y[n_p-1]);
	k--;
	if (k < 0)
		k = 9;
	for (let i1 = 0; i1 < n_p; i1++) {
		let x1 = kx + len * Math.cos(Math.PI * a1 / 180.0);
		let y1 = ky - len * Math.sin(Math.PI * a1 / 180.0);
		ctx.beginPath();
		ctx.moveTo(kx, ky);
		ctx.fillStyle   = cl[k];
		ctx.strokeStyle = cl[k];
		ctx.lineTo(x1, y1);
		for (let a = a1+1; a <= a2; a++) {
			x1 = kx + len * Math.cos(Math.PI * a / 180.0);
			y1 = ky - len * Math.sin(Math.PI * a / 180.0);
			ctx.lineTo(x1, y1);
		}
		ctx.closePath();
		ctx.fill();
		if (i1 < n_p-1) {
			a1 = a2;
			a2 = a1 + Math.round(3.60 * data_y[n_p-2-i1]);
			k--;
			if (k < 0)
				k = 9;
		}
	}
}

/****************************/
/* 散布図の描画             */
/*      coded by Y.Suganuma */
/****************************/
function ScatterDiagram()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// ｘ軸及びｙ軸のタイトルの表示
					//
	x_r    -= Math.floor(0.03 * (x_r - x_l));
	f_size  = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font      = f_size + "px 'ＭＳ ゴシック'";
	ctx.fillStyle = 'rgb(0, 0, 0)';
	if (title[1].length > 0 && title[1] != "-") {
		let met = ctx.measureText(title[1]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d - 5;
		ctx.fillText(title[1], px, py);
		y_d -= (f_size + 5);
	}
	if (title[2].length > 0 && title[2] != "-") {
		let met = ctx.measureText(title[2]);
		let px  = x_l;
		let py  = y_u + 4 * f_size / 5;
		ctx.fillText(title[2], px, py);
		y_u += 7 * f_size / 5;
	}
					//
					// ｘ軸，ｙ軸，及び，各軸の目盛り
					//
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	ctx.fillStyle   = "rgb(0, 0, 0)";
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font  = f_size + "px 'ＭＳ 明朝'";
	y_d      -= (f_size + 5);
							// ｙ軸
	let y1  = y_scale[0];
	let k   = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
	let len = 0;
	let b   = Math.pow(10, place_y);
	for (let i1 = 0; i1 < k+1; i1++) {
		let yy = Math.round(y1 * b).toString();
		if (place_y == 0)
			tx[i1] = yy;
		else {
			if (yy.length < place_y+1) {
				let n = place_y + 1 - yy.length;
				for (let i2 = 0; i2 < n; i2++)
					yy = "0" + yy;
			}
			tx[i1] = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
		}
		let met = ctx.measureText(tx[i1]);
		if (met.width > len)
			len = met.width;
		y1 += y_scale[2];
	}
	ctx.moveTo(x_l+len+10, y_u);
	ctx.lineTo(x_l+len+10, y_d);
	ctx.moveTo(x_r, y_u);
	ctx.lineTo(x_r, y_d);
	y1 = y_scale[0];
	let x1 = y_d;
	let sp = (y_d - y_u) / k;
	for (let i1 = 0; i1 < k+1; i1++) {
		let ky  = Math.floor(Math.round(x1));
		let met = ctx.measureText(tx[i1]);
		let k1  = met.width;
		let px  = x_l + len - k1;
		let py  = ky + 2 * f_size / 5;
		ctx.fillText(tx[i1], px, py);
		ctx.moveTo(x_l+len+10, ky);
		ctx.lineTo(x_r, ky);
		y1 += y_scale[2];
		x1 -= sp;
	}
	x_l += (len + 10);
							// ｘ軸
	k  = Math.floor((x_scale[1] - x_scale[0]) / (0.99 * x_scale[2]));
	x1 = x_scale[0];
	y1 = x_l;
	sp = (x_r - x_l) / k;
	b  = Math.pow(10, place_x);
	for (let i1 = 0; i1 < k+1; i1++) {
		let kx = Math.floor(Math.round(y1));
		let yy = Math.round(x1 * b).toString();
		let st;
		if (place_x == 0)
			st = yy;
		else {
			if (yy.length < place_x+1) {
				let n = place_x + 1 - yy.length;
				for (let i2 = 0; i2 < n; i2++)
					yy = "0" + yy;
			}
			st = yy.substr(0,yy.length-place_x) + "." + yy.substr(yy.length-place_x,place_x);
		}
		let met = ctx.measureText(st);
		let k1  = met.width;
		let px  = kx - k1 / 2;
		let py  = y_d + f_size;
		ctx.fillText(st, px, py);
		if (i1 < k) {
			ctx.moveTo(kx, y_d);
			ctx.lineTo(kx, y_u);
		}
		x1 += x_scale[2];
		y1 += sp;
	}
	ctx.stroke();
					//
					// グラフの表示
					//
	let cr = f_size / 4;
	if (cr == 0)
		cr = 1;
	for (let i1 = 0; i1 < n_p; i1++) {
		let kx = x_l + Math.floor((x_r - x_l) * (data_y[0][i1] - x_scale[0]) / (x_scale[1] - x_scale[0]));
		let ky = y_d - Math.floor((y_d - y_u) * (data_y[1][i1] - y_scale[0]) / (y_scale[1] - y_scale[0]));
		ctx.beginPath();
		ctx.arc(kx, ky, cr, 0, 2*Math.PI, false);
		ctx.fill();
	}
					//
					// 相関係数
					//
	let vii = 0.0;
	let vjj = 0.0;
	let vij = 0.0;
	let mi  = 0.0;
	let mj  = 0.0;
	for (let i1 = 0; i1 < n_p; i1++) {
		mi += data_y[0][i1];
		mj += data_y[1][i1];
	}
	mi /= n_p;
	mj /= n_p;
	for (let i1 = 0; i1 < n_p; i1++) {
		vii += (data_y[0][i1] - mi) * (data_y[0][i1] - mi);
		vjj += (data_y[1][i1] - mj) * (data_y[1][i1] - mj);
		vij += (data_y[0][i1] - mi) * (data_y[1][i1] - mj);
	}
	vii /= (n_p - 1);
	vjj /= (n_p - 1);
	vij /= (n_p - 1);
	x1 = vij / (Math.sqrt(vii) * Math.sqrt(vjj));
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let yy = Math.round(x1 * 1000);
	yy /= 1000;
	let st  = "相関係数： " + yy;
	let met = ctx.measureText(st);
	let k1  = met.width;
	let px  = x_r - met.width;
	let py  = y_u - f_size;
	ctx.fillText(st, px, py);
}

/****************************/
/* レーダーチャートの描画   */
/*      coded by Y.Suganuma */
/****************************/
function RadarChart()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx  = x_r - met.width - 5;
	cy  = y_u;
	cw  = met.width + 5;
	ch  = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let met = ctx.measureText(g_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		let k  = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(g_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// 軸，及び，軸の目盛り
					//
							// フォントサイズ
	f_size = Math.floor(0.7 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ 明朝'";
							// 大きさの決定
	let a   = 0.5 * Math.PI;
	let aa  = 2.0 * Math.PI / n_p;
	let x11 = 0.0;
	let x12 = 0.0;
	let x21 = 0.0;
	let x22 = 0.0;
	let y11 = 0.0;
	let y12 = 0.0;
	let y21 = 0.0;
	let y22 = 0.0;
	for (let i1 = 0; i1 < n_p; i1++) {
		let xx  = 100 * Math.cos(a);
		let yy  = 100 * Math.sin(a);
		let met = ctx.measureText(x_title[i1]);
		let k1  = met.width;
		if (i1 == 0) {
			x12 = 0.5 * k1;
			x22 = x12;
			y11 = 100.0;
			y12 = 5.0 * f_size / 4.0;
		}
		else if (Math.abs(xx) < 1.0e-5) {
			let x0 = 0.5 * k1;
			if (x0 > x12)
				x12 = x0;
			if (x0 > x22)
				x22 = x0;
			y21 = 100.0;
			y22 = f_size + 5.0;
		}
		else {
			if (yy < 0.0) {
				let y0 = -yy + 0.5 * f_size;
				if (y0 > y21+y22) {
					y21 = -yy;
					y22 = 0.5 * f_size;
				}
			}
			if (xx > 0.0) {
				let x0 = xx + k1 + 5.0;
				if (x0 > x21+x22) {
					x21 = xx;
					x22 = k1 + 5.0;
				}
			}
			else {
				let x0 = -xx + k1 + 5.0;
				if (x0 > x11+x12) {
					x11 = -xx;
					x12 = k1 + 5.0;
				}
			}
		}
		a += aa;
	}
	let x0 = x12 + x22;
	let xx = (x_r - x_l - x0 - 10) / (x11 + x21);
	let y0 = y12 + y22;
	let yy = (y_d - y_u - y0 - 10) / (y11 + y21);
	r = (xx < yy) ? xx : yy;
	let cr = Math.floor(100 * r);
	xx = x_l + r * x11 + x12 + 5.0;
	let cxx = Math.floor(xx + (x_r - x_l - r * x11 - x12 - r * x21 - x22 - 5) / 2);
	yy = y_u + r * y11 + y12 + 5.0;
	let cyy = Math.floor(yy + (y_d - y_u - r * y11 - y12 - r * y21 - y22 - 5) / 2);
							// 軸とタイトルの描画
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	let k = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2])) + 1;
	xx = cr / k;
	a  = 0.5 * Math.PI;
	aa = 2.0 * Math.PI / n_p;
	for (let i1 = 0; i1 < n_p; i1++) {
		let kx  = Math.round(cr * Math.cos(a));
		let ky  = Math.round(cr * Math.sin(a));
		let met = ctx.measureText(x_title[i1]);
		let k1  = met.width;
		ctx.moveTo(cxx, cyy);
		ctx.lineTo(cxx+kx, cyy-ky);
		yy = xx;
		for (let i2 = 0; i2 < k; i2++) {
			let kx0 = cxx + Math.round(yy * Math.cos(a));
			let ky0 = cyy - Math.round(yy * Math.sin(a));
			let kx1 = kx0 + Math.round(3 * Math.cos(a+0.5*Math.PI));
			let ky1 = ky0 - Math.round(3 * Math.sin(a+0.5*Math.PI));
			let kx2 = kx0 + Math.round(3 * Math.cos(a-0.5*Math.PI));
			let ky2 = ky0 - Math.round(3 * Math.sin(a-0.5*Math.PI));
			ctx.moveTo(kx1, ky1);
			ctx.lineTo(kx2, ky2);
			yy += xx;
		}
		if (i1 == 0) {
			let met = ctx.measureText(x_title[i1]);
			ctx.fillText(x_title[i1], cxx+kx-k1/2, cyy-ky-4*f_size/5);
			yy = xx;
			let sp = y_scale[0];
			for (let i2 = 0; i2 < k; i2++) {
				let kx0 = cxx + Math.round(yy * Math.cos(a)) + 5;
				let ky0 = cyy - Math.floor(Math.round(yy * Math.sin(a)) - 3 * f_size / 10);
				let b   = Math.pow(10, place_y);
				let zz  = Math.round(sp * b).toString();
				if (place_y == 0)
					tx[i2] = zz;
				else {
					if (zz.length < place_y+1) {
						let n = place_y + 1 - zz.length;
						for (let i2 = 0; i2 < n; i2++)
							zz = "0" + zz;
					}
					tx[i2] = zz.substr(0,zz.length-place_y) + "." + zz.substr(zz.length-place_y,place_y);
				}
				let met = ctx.measureText(tx[i2]);
				ctx.fillText(tx[i2], kx0, ky0);
				yy += xx;
				sp += y_scale[2];
			}
		}
		else {
			let met = ctx.measureText(x_title[i1]);
			let px;
			let py;
			if (kx == 0) {
				px = cxx + kx - k1 / 2;
				py = cyy - ky + 5 * f_size / 4;
			}
			else if (kx > 0) {
				px = cxx + kx + 5;
				py = cyy - ky + 3 * f_size / 10;
			}
			else {
				px = cxx + kx - k1 - 10;
				py = cyy - ky + 3 * f_size / 10;
			}
			ctx.fillText(x_title[i1], px, py);
		}
		a += aa;
	}
	ctx.stroke();
					//
					// グラフの表示
					//
	ctx.lineWidth = line_w;
	let pt = line_w / 2 + 3;

	let k1 = 0;
	for (let i1 = 0; i1 < n_g; i1++) {
		ctx.strokeStyle = cl[k1];
		ctx.fillStyle   = cl[k1];
		a   = 0.5 * Math.PI;
		aa  = 2.0 * Math.PI / n_p;
		let kx1 = 0;
		let ky1 = 0;
		let kx2 = 0;
		let ky2 = 0;
		for (let i2 = 0; i2 < n_p; i2++) {
			yy = xx + (cr - xx) * (data_y[i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]);
			let kx = cxx + Math.round(yy * Math.cos(a));
			let ky = cyy - Math.round(yy * Math.sin(a));
			if (line_m) {
				ctx.beginPath();
				ctx.arc(kx, ky, pt, 0, 2*Math.PI, false);
				ctx.fill();
			}
			if (i2 == 0) {
				kx2 = kx;
				ky2 = ky;
			}
			else {
				ctx.beginPath();
				ctx.moveTo(kx1, ky1);
				ctx.lineTo(kx, ky);
				ctx.stroke();
				if (i2 == n_p-1) {
					ctx.beginPath();
					ctx.moveTo(kx2, ky2);
					ctx.lineTo(kx, ky);
					ctx.stroke();
				}
			}
			kx1  = kx;
			ky1  = ky;
			a   += aa;
		}
		k1++;
		if (k1 > 9)
			k1 = 0;
	}
	ctx.lineWidth = 1;
}

/****************************/
/* ボード線図の描画         */
/*      coded by Y.Suganuma */
/****************************/
function Bode()
{
	let tx = new Array();
					//
					// 描画領域の設定
					//
	ctx.fillStyle  = 'rgb(255, 255, 255)';
	ctx.fillRect(10, 10, canvas.width-20, canvas.height-20);
	let x_l = 15;
	let x_r = canvas.width - 15;
	let y_u = 15;
	let y_d = canvas.height - 15;
					//
					// グラフタイトルの表示
					//
	let r      = 0.05;   // タイトル領域の割合
	let f_size = ((y_d - y_u) < (x_r - x_l)) ? Math.floor((y_d - y_u) * r) : Math.floor((x_r - x_l) * r);
	if (f_size < 5)
		f_size = 5;
	if (d_t) {
		ctx.fillStyle  = 'rgb(0, 0, 0)';
		ctx.font = f_size + "px 'ＭＳ ゴシック'";
		let met = ctx.measureText(title[0]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d;
		ctx.fillText(title[0], px, py);
		y_d -= f_size;
	}
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
					//
					// 表示切り替えボタンの設置
					//
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font = f_size + "px 'ＭＳ ゴシック'";
	let met = ctx.measureText(change);
	cx  = x_r - met.width - 5;
	cy  = y_u;
	cw  = met.width + 5;
	ch  = f_size + 5;
	ctx.fillStyle  = 'rgb(255, 215, 0)';
	ctx.fillRect(cx, cy, cw, ch);
	ctx.fillStyle  = 'rgb(0, 0, 0)';
	let px = cx + 2;
	let py = cy + f_size;
	ctx.fillText(change, px, py);
					//
					// 凡例の表示
					//
	if (d_g) {
		let han = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			let met = ctx.measureText(g_title[i1]);
			if (met.width > han)
				han = met.width;
		}
		han += 15;
		r    = 0.2;   // 凡例領域の割合
		let k1 = Math.floor((x_r - x_l) * r);
		if (han > k1)
			han = k1;
		let kx = x_r - han;
		let ky = y_u + 2 * f_size;
		let k  = 0;
		for (let i1 = 0; i1 < n_g; i1++) {
			ctx.fillStyle  = cl[k];
			ctx.fillRect(kx, ky-1, 10, 7);
			ctx.fillStyle  = 'rgb(0, 0, 0)';
			ctx.fillText(g_title[i1], kx+15, ky+2*f_size/5);
			k++;
			if (k > 9)
				k = 0;
			ky += (f_size + 5);
		}
		x_r -= (han + 10);
	}
	else
		x_r -= Math.floor(0.03 * (x_r - x_l));
					//
					// ｘ軸の対数
					//
	x_scale_org = x_scale[0];
	xx_scale    = new Array(3);
	xx_scale[0] = Math.log(x_scale[0]) / Math.log(10.0);
	xx_scale[1] = Math.log(x_scale[1]) / Math.log(10.0);
	xx_scale[2] = 1.0;
	data_xx     = new Array(n_g);
	for (let i1 = 0; i1 < n_g; i1++) {
		data_xx[i1] = new Array(n_p);
		for (let i2 = 0; i2 < n_p; i2++)
			data_xx[i1][i2] = Math.log(data_x[i1][i2]) / Math.log(10.0);
	}
					//
					// ｘ軸及びｙ軸のタイトルの表示
					//
	ctx.fillStyle = 'rgb(0, 0, 0)';
	if (title[1].length > 0 && title[1] != "-") {
		let met = ctx.measureText(title[1]);
		let px  = (x_l + x_r) / 2 - met.width / 2;
		let py  = y_d - 5;
		ctx.fillText(title[1], px, py);
		y_d -= (f_size + 5);
	}
	else
		y_d -= (f_size / 2 + 5);
	if (title[2].length > 0 && title[2] != "-") {
		let met = ctx.measureText(title[2]);
		let px  = x_l;
		let py  = y_u + 4 * f_size / 5;
		ctx.fillText(title[2], px, py);
		y_u += 4 * f_size / 5;
	}
					//
					// ｘ軸，ｙ軸，及び，各軸の目盛り
					//
	ctx.lineWidth   = 1;
	ctx.strokeStyle = "rgb(0, 0, 0)";
	f_size = Math.floor(0.8 * f_size);
	if (f_size < 5)
		f_size = 5;
	ctx.font  = f_size + "px 'ＭＳ 明朝'";
	y_d     -= 5 * f_size / 4;
	y_u     += 10;
	x_l     += f_size;
							// ｙ軸
	let k_y = Math.floor((y_scale[1] - y_scale[0]) / (0.99 * y_scale[2]));
	let y1  = y_scale[0];
	let len = 0;
	let b   = Math.pow(10, place_y);
	for (let i1 = 0; i1 < k_y+1; i1++) {
		let yy = Math.round(y1 * b).toString();
		if (place_y == 0)
			tx[i1] = yy;
		else {
			if (yy.length < place_y+1) {
				let n = place_y + 1 - yy.length;
				for (let i2 = 0; i2 < n; i2++)
					yy = "0" + yy;
			}
			tx[i1] = yy.substr(0,yy.length-place_y) + "." + yy.substr(yy.length-place_y,place_y);
		}
		let met = ctx.measureText(tx[i1]);
		if (met.width > len)
			len = met.width;
		y1 += y_scale[2];
	}
	ctx.moveTo(x_l+len+5, y_u);
	ctx.lineTo(x_l+len+5, y_d);
	ctx.moveTo(x_r, y_u);
	ctx.lineTo(x_r, y_d);
	ctx.stroke();
	y1 = y_scale[0];
	let x1 = y_d;
	let sp = (y_d - y_u) / k_y;
	for (let i1 = 0; i1 < k_y+1; i1++) {
		let ky  = Math.round(x1);
		let met = ctx.measureText(tx[i1]);
		let k1  = met.width;
		let px  = x_l + len - k1;
		let py  = ky + 3 * f_size / 10;
		ctx.fillText(tx[i1], px, py);
		ctx.moveTo(x_l+len+5, ky);
		ctx.lineTo(x_r, ky);
		ctx.stroke();
		y1 += y_scale[2];
		x1 -= sp;
	}
	x_l += (len + 5);
							// ｘ軸
	let k_x = Math.floor((xx_scale[1] - xx_scale[0]) / (0.99 * xx_scale[2]));
	x1  = x_scale_org;
	sp  = (x_r - x_l) / k_x;
	y1 = x_l;
	b  = Math.pow(10, place_x);
	for (let i1 = 0; i1 < k_x+1; i1++) {
		let kx = Math.round(y1);
		let yy = Math.round(x1 * b).toString();
		if (place_x == 0)
			tx[i1] = yy;
		else {
			if (yy.length < place_x+1) {
				let n = place_x + 1 - yy.length;
				for (let i2 = 0; i2 < n; i2++)
					yy = "0" + yy;
			}
			tx[i1] = yy.substr(0,yy.length-place_x) + "." + yy.substr(yy.length-place_x,place_x);
		}
		let met = ctx.measureText(tx[i1]);
		let k1  = met.width;
		let px  = kx - k1 / 2;
		let py  = y_d + f_size + 3;
		ctx.fillText(tx[i1], px, py);
		ctx.moveTo(kx, y_d);
		ctx.lineTo(kx, y_u);
		ctx.stroke();
		if (i1 != k_x) {
			ctx.beginPath();
			ctx.strokeStyle = 'rgb(128, 128, 128)';
			for (let i2 = 2; i2 <= 9; i2++) {
				let y2 = Math.log(x1 * i2) / Math.log(10.0);
				let kx = x_l + Math.round(((x_r - x_l) * (y2 - xx_scale[0]) / (xx_scale[1] - xx_scale[0])));
				ctx.moveTo(kx, y_d);
				ctx.lineTo(kx, y_u);
				ctx.stroke();
			}
			ctx.beginPath();
			ctx.strokeStyle = 'rgb(0, 0, 0)';
		}
		x1 *= 10.0;
		y1 += sp;
	}
					//
					// グラフの表示
					//
	ctx.lineWidth = line_w;
	let k1 = 0;
	for (let i1 = 0; i1 < n_g; i1++) {
		ctx.beginPath();
		ctx.strokeStyle = cl[k1];
		let kx1 = 0;
		let ky1 = 0;
		for (let i2 = 0; i2 < n_p; i2++) {
			let kx = x_l + Math.floor((x_r - x_l) * (data_xx[i1][i2] - xx_scale[0]) / (xx_scale[1] - xx_scale[0]));
			let ky = y_d - Math.floor((y_d - y_u) * (data_y[i1][i2] - y_scale[0]) / (y_scale[1] - y_scale[0]));
			if (i2 > 0) {
				ctx.moveTo(kx1, ky1);
				ctx.lineTo(kx, ky);
				ctx.stroke();
			}
			kx1 = kx;
			ky1 = ky;
		}
		k1++;
		if (k1 >= cl.length)
			k1 = 0;
	}
}

/**********************************/
/* 表示の切り替えボタンのクリック */
/**********************************/
function Click(event)
{
	let x_now;
	let y_now;
	if (navigator.appName.indexOf("Explorer") >= 0) {
		x_now = event.x - x_base;
		y_now = event.y - y_base;
	}
	else {
		x_now = event.pageX - x_base;
		y_now = event.pageY - y_base;
	}
					// 縦表示，横表示の変更
	if (kind <= 3 && x_now > cx && x_now < cx+cw/2 && y_now > cy && y_now < cy+ch) {
		if (ver) {
			ver    = false;
			change = "縦　色";
		}
		else {
			ver    = true;
			change = "横　色";
		}

		ctx.beginPath();
		ctx.clearRect(0, 0, canvas.width, canvas.height);

		if (kind == 0)
			BarGraph();
		else if (kind == 1)
			LineGraph1();
		else if (kind == 2)
			LineGraph2();
		else
			StackGraph();
	}
					// 色や線の太さの変更
	else if (kind <= 3 && x_now > cx+cw/2 && x_now < cx+cw && y_now > cy && y_now < cy+ch ||
             (kind == 4 || kind >= 6) && x_now > cx && x_now < cx+cw && y_now > cy && y_now < cy+ch) {
		let n = n_g;
		if (kind == 3 || kind == 4)
			n = n_p;
		if (n > 10)
			n = 10;
		document.getElementById('cl_line').style.display = "";
		for (let i1 = 0; i1 < n; i1++) {
			let id = "c" + i1;
			document.getElementById(id).style.display = "";
		}
		for (let i1 = n; i1 < 10; i1++) {
			let id = "c" + i1;
			document.getElementById(id).style.display = "none";
		}
		if (kind == 1 || kind == 2 || kind == 6 || kind == 7)
			document.getElementById('line_w').style.display = "";
		else
			document.getElementById('line_w').style.display = "none";
		if (kind == 1 || kind == 2 || kind == 6)
			document.getElementById('line_m').style.display = "";
		else
			document.getElementById('line_m').style.display = "none";
	}
}

/********************************************************/
/* 「OK」ボタンがクリックされたとき（線の太さ等の設定） */
/********************************************************/
function D_Change()
{
					// 線の太さ
	if (kind == 1 || kind == 2 || kind == 6 || kind == 7)
		line_w = parseInt(document.getElementById('l_w').value);
					// マーク
	if (kind == 1 || kind == 2 || kind == 6)
		line_m = document.getElementById('l_m1').checked ? true : false;
					// 再描画
	document.getElementById('cl_line').style.display = "none";
	graph(gpp);
}

/******************************************/
/* TextField が変更されたとき（色の変更） */
/******************************************/
function c_change(sw)
{
	let rgb1 = "rgb(";
	let str = "r" + sw;
	let r1 = document.getElementById(str).value;
	if (r1 == "")
		r1 = "0";
	rgb1 = rgb1 + r1 + ",";
	str = "g" + sw;
	let g1 = document.getElementById(str).value;
	if (g1 == "")
		g1 = "0";
	rgb1 = rgb1 + g1 + ",";
	str = "b" + sw;
	let b1 = document.getElementById(str).value;
	if (b1 == "")
		b1 = "0";
	rgb1 = rgb1 + b1 + ")";
	cl[sw] = rgb1;
	clr[sw] = r1;
	clg[sw] = g1;
	clb[sw] = b1;
	str = "rgb" + sw;
	document.getElementById(str).style.backgroundColor = cl[sw];
}
