/**********************************/
/* ２次元配列の受け渡し（方法１） */
/*      coded by Y.Suganuma       */
/**********************************/
#include <stdio.h>

void seki(int, int, int, double [][3], double [][2], double [][2]);

int main()
{
/*
	 関数の呼び出し
*/
	double a[2][3] = {{1.0, 2.0, 3.0}, {4.0, 5.0, 6.0}};
	double b[3][2] = {{1.0, 0.0}, {0.0, 1.0}, {0.0, 0.0}};
	double c[2][2];
	seki(2, 3, 2, a, b, c);
/*
	 結果の出力
*/
	int i1;
	for (i1 = 0; i1 < 2; i1++) {
		int i2;
		for (i2 = 0; i2 < 2; i2++)
			printf("%f ", c[i1][i2]);
		printf("\n");
	}

	return 0;
}
/**************************************/
/* 行列の積                           */
/*      n,m,l : 次元数                */
/*      a : n x m                     */
/*      b : m x l                     */
/*      c : 計算結果が入る行列，n x l */
/**************************************/
void seki(int n, int m, int l, double a[][3], double b[][2], double c[][2])
{
	int i1, i2, i3;

	for (i1 = 0; i1 < n; i1++) {
		for (i2 = 0; i2 < l; i2++) {
			c[i1][i2] = 0;
			for (i3 = 0; i3 < m; i3++)
				c[i1][i2] += a[i1][i3] * b[i3][i2];
		}
	}
}
