/**********************************/
/* ２次元配列の受け渡し（方法２） */
/*      coded by Y.Suganuma       */
/**********************************/
#include <stdio.h>

void seki(int, int, int, double**, double**, double**);

int main()
{
/*
	 領域の確保と値の設定
*/
	double **a = new double* [2];
	double **b = new double* [3];
	double **c = new double* [2];

	for (int i1 = 0; i1 < 2; i1++) {
		c[i1] = new double [2];
		if (i1 == 0)
			a[i1] = new double [3] {1, 2, 3};
		else
			a[i1] = new double [3] {4, 5, 6};
	}

	for (int i1 = 0; i1 < 3; i1++) {
		if (i1 == 0)
			b[i1] = new double [2] {1, 0};
		else if (i1 == 1)
			b[i1] = new double [2] {0, 1};
		else
			b[i1] = new double [2] {0, 0};
	}
/*
	 関数の呼び出し
*/
	seki(2, 3, 2, a, b, c);
/*
	 結果の出力
*/
	for (int i1 = 0; i1 < 2; i1++) {
		for (int i2 = 0; i2 < 2; i2++)
			printf("%f ", c[i1][i2]);
		printf("\n");
	}

	return 0;
}
/**************************************/
/* 行列の積                           */
/*      n,m,l : 次元数                */
/*      a : n x m                     */
/*      b : m x l                     */
/*      c : 計算結果が入る行列，n x l */
/**************************************/
void seki(int n, int m, int l, double **a, double **b, double **c)
{
	for (int i1 = 0; i1 < n; i1++) {
		for (int i2 = 0; i2 < l; i2++) {
			c[i1][i2] = 0;
			for (int i3 = 0; i3 < m; i3++)
				c[i1][i2] += a[i1][i3] * b[i3][i2];
		}
	}
}
