/****************************/
/* 複素数（フレンド関数）   */
/*      coded by Y.Suganuma */
/****************************/
#include <iostream>

using namespace std;

class Complex {
		double r;
		double i;
	public:
		Complex (double a = 0.0, double b = 0.0);   // constructor
	friend Complex operator +(Complex a, Complex b);   // overload of +
	friend ostream& operator << (ostream&, Complex);   // overload of <<
};

Complex::Complex(double a, double b)
{
	r = a;
	i = b;
}

Complex operator +(Complex a, Complex b)
{
	Complex c;
	c.r = a.r + b.r;
	c.i = a.i + b.i;
	return c;
}

ostream& operator << (ostream& stream, Complex a)
{
	stream << "(" << a.r << ", " << a.i << ")\n";
	return stream;
}

int main()
{
	Complex w, x(1.0, 2.0), y(3.0), z;
	z = x + y;
	w = 5.0 + x;
	cout << "z " << z;
	cout << "w " << w;
	return 0;
}
