/****************************/
/* 代入問題の解決           */
/*      coded by Y.Suganuma */
/****************************/
#include <iostream>
using namespace std;

/***********************/
/* クラスVector2の定義 */
/***********************/
class Vector2 {
	public:
		int n;
		double *x;
		Vector2 (int n1, double x1, double x2)     // コンストラクタ
		{
			n    = n1;
			x    = new double [2];
			x[0] = x1;
			x[1] = x2;
		}
		~Vector2 () {delete [] x;}   // デストラクタ
		Vector2& operator= (const Vector2 &);   // ＝のオーバーロード
};

/*******************************/
/* ＝のオーバーロード          */
/*      a = b (a.operator=(b)) */
/*******************************/
Vector2& Vector2::operator= (const Vector2 &b)
{
	if (&b == this)                 // 自分自身への代入を防ぐ
		return *this;
	else {
		delete [] x;                // 代入する前のメモリを解放
		x    = new double [2];      // メモリの確保
		n    = b.n;                 // 値の代入
		x[0] = b.x[0];
		x[1] = b.x[1];
		return *this;
	}
}

/************/
/* main関数 */
/************/
int main()
{
	Vector2 v3(3, 0.0, 0.0), v4(4, -1.0, -2.0);
						// 代入前
	cout << endl;
	cout << "      v3（代入前） " << v3.n << " " << v3.x[0] << " " << v3.x[1] << endl;
	cout << "      v4（代入前） " << v4.n << " " << v4.x[0] << " " << v4.x[1] << endl;
						// 代入
	v3 = v4;
						// 代入後
	cout << endl;
	cout << "      v3（v4をv3に代入後） " << v3.n << " " << v3.x[0] << " " << v3.x[1] << endl;
	cout << "      v4（v4をv3に代入後） " << v4.n << " " << v4.x[0] << " " << v4.x[1] << endl;
						// 値の変更
	v4.n    = 5;
	v4.x[0] = 1.5;
						// 変更後の値
	cout << endl;
	cout << "      v3（v4.nを5，v4.x[0]を1.5に変更後） " << v3.n << " " << v3.x[0] << " " << v3.x[1] << endl;
	cout << "      v4（v4.nを5，v4.x[0]を1.5に変更後） " << v4.n << " " << v4.x[0] << " " << v4.x[1] << endl;

	return 0;
}
