/****************************/
/* 派生クラス               */
/*      coded by Y.Suganuma */
/****************************/
#include <iostream>

/********************/
/* クラスOya1の定義 */
/********************/
class Oya1 {
		int priv1;
	protected:
		int prot1;
	public:
		int pub1;
		Oya1 (int n1, int n2, int n3)   // コンストラクタ
		{
			priv1 = n1;
			prot1 = n2;
			pub1  = n3;
		}
		void output1(int sw)   // 出力
		{
			switch (sw) {
				case 0:
					std::cout << "   priv1 " << priv1 << std::endl;
					break;
				case 1:
					std::cout << "   prot1 " << prot1 << std::endl;
					break;
				case 2:
					std::cout << "   pub1 " << pub1 << std::endl;
					break;
			}
		}
};

/********************/
/* クラスOya2の定義 */
/********************/
class Oya2 {
		int priv2;
	public:
		int pub2_1, pub2_2;
		void set(int sw, int n)   // 値の設定
		{
			switch (sw) {
				case 0:
					priv2 = n;
					break;
				case 1:
					pub2_1 = n;
					break;
				case 2:
					pub2_2 = n;
					break;
			}
		}
		void output2(int sw)   // 出力
		{
			switch (sw) {
				case 0:
					std::cout << "   priv2 " << priv2 << std::endl;
					break;
				case 1:
					std::cout << "   pub2_1 " << pub2_1 << std::endl;
					break;
				case 2:
					std::cout << "   pub2_2 " << pub2_2 << std::endl;
 					break;
			}
		}
};

/**********************/
/* クラスkodomoの定義 */
/**********************/
class Kodomo : public Oya1, Oya2 {
	public:
					// コンストラクタ（基底クラスのコンストラクタのために必要）
		Kodomo (int n1, int n2, int n3) : Oya1(n1, n2, n3) {}
		void output_k(int sw)   // 出力
		{
			switch (sw) {
				case 0:   // 親のprivate変数にはアクセスできない
					std::cout << "   priv1 ?" << std::endl;
					break;
				case 1:
					std::cout << "   prot1 " << prot1 << std::endl;
					break;
				case 2:
					std::cout << "   pub1 " << pub1 << std::endl;
					break;
				case 3:   // 親のprivate変数にはアクセスできない
					std::cout << "   priv2 ?" << std::endl;
					break;
				case 4:
					std::cout << "   pub2_1 " << pub2_1 << std::endl;
					break;
				case 5:
					std::cout << "   pub2_2 " << pub2_2 << std::endl;
					break;
			}
		}
					// Oya2のpublic変数の一部と関数をpubulicに移動
		using Oya2::pub2_1;
		using Oya2::set;
		using Oya2::output2;
};

/******************/
/* mainプログラム */
/******************/
int main()
{
			// 親１
	Oya1 o1(10, 20, 30);

	std::cout << "親１\n";
	o1.output1(0);   // priv1 の出力
	o1.output1(1);   // prot1 の出力
	o1.output1(2);   // pub1 の出力
	std::cout << "   (from main) priv1 ? prot1 ? pub1 " << o1.pub1 << std::endl;
			// 親２
	Oya2 o2;

	std::cout << "親２\n";
	o2.set(0, 50);
	o2.set(1, 60);
	o2.set(2, 70);
	o2.output2(0);   // priv2 の出力
	o2.output2(1);   // pub2_1 の出力
	o2.output2(2);   // pub2_2 の出力
	std::cout << "   (from main) priv2 ? pub2_1 " << o2.pub2_1 << " pub2_2 " << o2.pub2_2 << std::endl;
			// 子供
	Kodomo k(100, 200, 300);   // 親(Oya1)のコンストラクタのための引数

	std::cout << "子供\n";
				// Oya1から継承した部分
	std::cout << "      Oya1から継承した関数を利用\n";
	k.output1(0);   // Oya1から継承した priv1 の出力
	k.output1(1);   // Oya1から継承した prot1 の出力
	k.output1(2);   // Oya1から継承した pub1 の出力
	std::cout << "      Kodomoの関数を利用\n";
	k.output_k(0);   // Oya1から継承した priv1 の出力（不可）
	k.output_k(1);   // Oya1から継承した prot1 の出力
	k.output_k(2);   // Oya1から継承した pub1 の出力
	std::cout << "   (from main) priv1 ? prot1 ? pub1 " << k.pub1 << std::endl;
							// pub1 はパブリック部分に継承されるためmainから参照可
				// Oya2から継承した部分
	std::cout << "      Oya2から継承した関数を利用\n";
	k.set(0, 500);
	k.set(1, 600);
	k.set(2, 700);
	k.output2(0);   // Oya2から継承した priv2 の出力
	k.output2(1);   // Oya2から継承した pub2_1 の出力
	k.output2(2);   // Oya2から継承した pub2_2 の出力
	std::cout << "      Kodomoの関数を利用\n";
	k.output_k(3);   // Oya2から継承した priv2 の出力（不可）
	k.output_k(4);   // Oya2から継承した pub2_1 の出力
	k.output_k(5);   // Oya2から継承した pub2_2 の出力
	std::cout << "   (from main) priv2 ? pub2_1 " << k.pub2_1 << " pub2_2  ?" << std::endl;
							// pub2_1 はパブリック部分に移動されたためmainから参照可

	return 0;
}
