/****************************/
/* ファイル入出力           */
/*      coded by Y.Suganuma */
/****************************/
#include <iostream>
#include <fstream>
#include <stdlib.h>
using namespace std;

/*******************/
/* クラスXyzの定義 */
/*******************/
class Xyz
{
	public:
		int x, y, z;
		Xyz(int a, int b, int c)   /* コンストラクタ */
		{
			x = a;
			y = b;
			z = c;
		}
	friend ostream& operator << (ostream &, Xyz);
};

/******************************************/
/* 座標の表示（演算子<<のオーバーロード） */
/******************************************/
ostream & operator << (ostream &stream, Xyz ten)
{
	stream << "   (" << ten.x << ", ";
	stream << ten.y << ", ";
	stream << ten.z << ")\n";
	return stream;
}

/************/
/* main関数 */
/************/
int main()
{
	int n1, n2, n3;
                // ファイルのオープン
	ifstream in("test1.txt");
	if (!in) {
		cout << "***error  入力ファイルを開けません\n";
		exit(1);
	}

	ofstream out("test.txt");
	if (!out) {
		cout << "***error  出力ファイルを開けません\n";
		exit(1);
	}
                // データ入力と出力
	while (!in.eof()) {
		in >> n1 >> n2 >> n3;
		Xyz a(n1, n2, n3);
		out << a;
	}
                // ファイルのクローズ
	in.close();
	out.close();

	return 0;
}
